/* Copyright (C) 1995 Charles Sandmann (sandmann@clio.rice.edu)
   This software may be freely distributed with above copyright, no warranty.
   Based on code by DJ Delorie, it's really his, enhanced, bugs fixed. */

/* Small code changes by Brian Bacon to furthur the development of DYNCOM */

#include <io.h>
#include <stdlib.h>
#include <errno.h>
#include "dyncom.h"

void *_dcm_load(char *name, DCM *d)
{
  int h;

  h = _open(name, 0);
  if (h < 0)
    return 0;
  _read(h, &d->hdr, sizeof(dcm_header));
  if (d->hdr.magic != DCM_MAGIC)
  {
    _close(h);
    errno = ENOEXEC;
    return 0;
  }

  d->data = (char *)malloc(d->hdr.element_size);
  if (d->data == 0)
  {
    _close(h);
    errno = ENOMEM;
    return 0;
  }

  _read(h, d->data, d->hdr.element_size);

  {
    long relocs[d->hdr.nrelocs];
    int i;
    _read(h, relocs, sizeof(long)*d->hdr.nrelocs);
    _close(h);

    for (i=0; i<d->hdr.nrelocs; i++)
      *(long *)(d->data + relocs[i]) += (int)d->data;
  }

  return (void *)(d->data + d->hdr.symbol_offset);
}

void _dcm_unload(DCM *d)
{
  free(d->data);
}
