#define userbmptop      13
#define MAXBUTTONS      1000
#define MAXWINDOWS      20
#define MAXEDITBOXES    50
#define MAXICONS        2000	//was 300 but need more for filemanager
#define MAXTEXTBOXES    50
#define MAXLISTBOXES    50
#define MAXZ		60

FONT *monofont;
int guitrans;
int guiblue;
int guiwhite;
int guigray;
int guired;
int screen_w;
int screen_h;
BITMAP *wallpaper;
BITMAP *mouse;
BITMAP *mousebuff;
char wallpaperfilename[100];
int key;
int lastmb;     //the last mouse button that was pressed when
                // a button was clicked on
int mainwin;
int LastButton;

void CheckAllButtons(int winid);
void MoveWin(int winid);
void BlankHandler();
void SetFocusOn(int thiswin);
void RefreshDesktop();
void RefreshEditBox(int boxid);
void RefreshWin(int winid);
void GUI_time(int data);
void demoteallwins();
void initdesktop();

typedef struct buttons BUTTONS;      
struct buttons{
        int used;
        int x;
        int y;
        int x2;
        int y2;
        int color;
        char *caption;
        void (*CallBack)(int data);
        void (*CallBackb)(int data);
        int data;
        int win;
        int enabled;
        int type;       //0 is regular button - 1 is a special color button - 2 is an icon - 3 a label
        BITMAP *bmp;
};
BUTTONS button[MAXBUTTONS];

typedef struct listboxes LISTBOXES;     //for the file selector
struct listboxes{
        int used;
        char *text;
        int win;
        int line;
        int maxlines;
        char selection[60];
        int x;
        int y;
        int x2;
        int y2;
        int data;
        void (*CallBack)(int data);
};
LISTBOXES listbox[MAXLISTBOXES];

typedef struct hiddens HIDDENS;
struct hiddens{
        int used;
        char caption[5];
        int y;
        int button;
        int win;
};
HIDDENS hidden[100];

typedef struct icons ICONS;      
struct icons{
        int used;
        int x;
        int y;
        int x2;
        int y2;
        int color;
        char *caption;
        void (*CallBack)(int data);
        int data;
        int enabled;
        BITMAP *bmp;
	int type;	//1 if its a desktop icon
};
ICONS icon[MAXICONS];

typedef struct editboxes EDITBOXES;      
struct editboxes{
        int used;
        int x;
        int y;
        int x2;
        int y2;
        int pointer;
        char *text;
        int win;
        int hasfocus;
	int data;
	BITMAP *bmp;
	void (*CallBack)(int data);
};
EDITBOXES editbox[MAXEDITBOXES];

typedef struct windows WINDOWS;  
struct windows{
        int used;
        int x;
        int y;
	int z;
        int w;
        int h;
        int visible;    //0 is invisible
        int exitbutton;
        int movebutton;
        int hidebutton;
	int ismenu;
        char *caption;
        void (*CallBack)(int data);
        BITMAP *bmp;
};
WINDOWS guiwin[MAXWINDOWS];


int MakeButton(int winid,int x,int y,char *caption,void(*CallBack)(int data),int data);
int MakeWindow(int x,int y,int w,int h,char *caption,void (*CallBack)(int data),int data);
int MakeColorButton(int winid,int x,int y,int w,int h,int c,char *caption,void(*CallBack)(int data),int data);
void RefreshWin(int winid);
void RefreshDesktop();
int CurrentWindow();
void BlankHandler();
void RefreshIcons();
int GetKey();
void PutKey(int i);
void ShowWin(int winid);
void CloseWin(int winid);
int AddListBox(int winid,int x,int y,int charswide,int maxlines,void (*CallBack)(int data),int data);
int AddEditBox(int winid,int x,int y,int w,char *textstring,void (*CallBack)(int data),int data);
void RefreshListBox(int id);
void AddListItem(int id,char *text);
void ResetListBox(int id);

#include "textbox.h"
#include "filebrow.h"
#include "menus.h"

int GetLastMouseB(void)
{
        int temp;
        temp=lastmb;
        lastmb=0;
        return temp;
};

void SystemMessage(char *message)
{
        int wid;
        int tid;
        wid=MakeWindow(100,100,337,265,"System Message",BlankHandler,0);
        tid=AddTextBox(wid,3,22,33,15,message);
        //textprintf_centre(guiwin[temp].bmp,SystemFont(),(strlen(message)*9+10)/2,40,0,message);
        MakeButton(wid,140,245," Ok ",CloseWin,wid);
        SetFocusOn(wid);
        RefreshTextBox(tid);
        RefreshWin(wid);
};

void GetWinInfo(int id,int *x,int *y)
{
        if(guiwin[id].used!=1)
        {
                x=0;
                y=0;
                return;
        }
        *x=guiwin[id].x;
        *y=guiwin[id].y;
};

void FreeIcon(int id)
{
        //free an icon handle
        button[id].used=0;
        destroy_bitmap(button[id].bmp);
};

void GetMouse(int *x,int *y,int *b,int winid)
{
        int mx,my,mb;
        int wx,wy;
        int test;
        getmouse(&mx,&my,&mb);
        test=MouseOver(winid);
        if(test==0)
        {
                *x=0;*y=0;*b=0;
                return;
        }
        wx=guiwin[winid].x;
        wy=guiwin[winid].y;
        *x=mx-wx;*y=my-wy;*b=mb;
};

void PutKey(int i)
{
	key=i;
}

int GetKey()
{
	int i;
	i=key;
	key=0;
        return i;
};

void ResetListBox(int id)
{
        if(listbox[id].used!=1){return;}
        listbox[id].line=1;
	memset(listbox[id].text,0,10000);
        RefreshListBox(id);
};

char *GetListBoxSelection(int id)
{
        return listbox[id].selection;
};

void ListBoxUp(int id)
{
        listbox[id].line=listbox[id].line-listbox[id].maxlines-1;
        if(listbox[id].line<1)
                listbox[id].line=1;
        RefreshListBox(id);
        RefreshWin(listbox[id].win);
};

void ListBoxDown(int id)
{
        listbox[id].line=listbox[id].line+listbox[id].maxlines-1;
        RefreshListBox(id);
        RefreshWin(listbox[id].win);
};

void promoteallwins()	//should only be called when the current window is closed!!!!!!!!
{
	int cnt;
	cnt=0;
	do{
		if(guiwin[cnt].used==1 )
		{
			//find a freespot
			guiwin[cnt].z--;
		}
		if(cnt==MAXWINDOWS)
			break;
		cnt++;
	}while(1);
}

void demoteallwins()
{
	int cnt;
	int temp;
	cnt=0;
	do{
		if(guiwin[cnt].used==1 )
		{
			//find a freespot
			guiwin[cnt].z++;
		}
		if(cnt==MAXWINDOWS)
			break;
		cnt++;
	}while(1);
	//now we have to see if any z's are over 50 then bring them down lower
	temp=getzwin(50);
	if(temp!=(-1))
	{
		cnt=49;
		do{
			if(getzwin(cnt)==(-1))
			{
				guiwin[temp].z=cnt;
				break;
			}
			cnt--;
			if(cnt==0){break;};
		}while(1);
	}

}

void CheckAllListBoxes(int winid)
{
        int x,y,x2,y2,temp;
        int mx,my,mb;
        int selected;
        int cnt;
        char *tok;
        char *items;
        int l,wl;
        if(guiwin[winid].used!=1){return;}
        temp=0;
        cnt=0;
        getmouse(&mx,&my,&mb);
	lastmb=mb;
	items=(char *)malloc(10000);
        do{
                temp++;
                if(listbox[temp].used==1 && listbox[temp].win==winid)
                {
                        x=listbox[temp].x+guiwin[winid].x;
                        y=listbox[temp].y+guiwin[winid].y;
                        x2=listbox[temp].x2+guiwin[winid].x;
                        y2=listbox[temp].y2+guiwin[winid].y;
                        l=listbox[temp].line;
                        if(mb!=0 && mx>x && mx<x2 && my>y && my<y2)
                        {
                                //mouse is pressed and over the listbox, now get the selection
                                do{
                                        if(my>y+(cnt*14) && my<y+(cnt*14)+14)
                                        {
                                                scare_mouse();
                                                rect(screen,x,y+(cnt*14),x2,y+(cnt*14)+14,guired);
                                                unscare_mouse();
                                                selected=cnt;
                                                break;
                                        };
                                        cnt=cnt+1;
                                }while(cnt<listbox[temp].maxlines+1);
                                cnt=0;
                                selected=selected+l-1;          //in case starting line is not the first
                                strcpy(items,listbox[temp].text);
                                tok=strtok(items,";");
                                do{
                                        if(cnt==selected)
                                        {
                                                strcpy(listbox[temp].selection,tok);
                                                listbox[temp].CallBack(listbox[temp].data);
                                                break;
                                        }
                                        cnt++;
                                        tok=strtok(0,";");
                                }while(tok!=0);
                                do{
                                        getmouse(&mx,&my,&mb);
                                }while(mb!=0);
                        }
                }
        }while(temp<MAXLISTBOXES);
	free((void *)items);
};

void RefreshListBox(int id)
{
        int x,y,x2,y2,temp;
        int winid;
        char *tok;
        char *items;
        int l;
        int wl;
        if(listbox[id].used!=1){return;}
	items=(char *)malloc(10000);
        strcpy(items,listbox[id].text);
        winid=listbox[id].win;
        x=listbox[id].x;
        y=listbox[id].y;
        x2=listbox[id].x2;
        y2=listbox[id].y2;
        l=listbox[id].line;
        rectfill(guiwin[winid].bmp,x,y,x2,y2,guiwhite);
        rect(guiwin[winid].bmp,x,y,x2,y2,0);
        //line(guiwin[winid].bmp,x2,y,x2,y2,guiwhite);
        //line(guiwin[winid].bmp,x,y2,x2,y2,guiwhite);
        tok=strtok(items,";");
        temp=(0);
        wl=0;
        do{
                if(tok==0){break;}
                temp++;
                if(temp>l-1 && wl<listbox[id].maxlines+1)
                {
                        textprintf(guiwin[winid].bmp,SystemFont(),x+2,y+2+(wl*14),0,tok);
                        wl++;
                }
                tok=strtok(0,";");
        }while(tok!=0);
	free((void *)items);
};

void AddListItem(int id,char *text)
{
        if(listbox[id].used==1)
        {
                strcat(listbox[id].text,text);
                strcat(listbox[id].text,";");
                RefreshListBox(id);
        }
};

int AddListBox(int winid,int x,int y,int charswide,int maxlines,void (*CallBack)(int data),int data)
{
        int temp;
        int x2,y2;
        if(guiwin[winid].used!=1){return 0;}
        temp=0;
        do{
                temp=temp+1;
                if(listbox[temp].used==0)
                {
                        listbox[temp].used=1;
                        listbox[temp].x=x;
                        listbox[temp].y=y;
                        listbox[temp].x2=x+(charswide*10)+4;
                        listbox[temp].y2=y+(maxlines*14)+14;
                        listbox[temp].win=winid;
                        listbox[temp].maxlines=maxlines;
                        listbox[temp].line=1;
                        listbox[temp].CallBack=CallBack;
                        listbox[temp].data=data;
			listbox[temp].text=(char *)malloc(10000);
			memset(listbox[temp].text,0,10000);
                        strcpy(listbox[temp].selection,"");
                        break;
                }
        }while(temp<MAXLISTBOXES);
        x2=listbox[temp].x2;
        y2=listbox[temp].y2;
        rectfill(guiwin[winid].bmp,x,y,x2,y2,guiwhite);
        rect(guiwin[winid].bmp,x,y,x2,y2,0);
        //line(guiwin[winid].bmp,x2,y,x2,y2,guiwhite);
        //line(guiwin[winid].bmp,x,y2,x2,y2,guiwhite);
        MakeButton(winid,x2+2,y,"-",ListBoxUp,temp);
        MakeButton(winid,x2+2,y2-15,"+",ListBoxDown,temp);
        RefreshWin(winid);
        return temp;
};

void DestroyButton(int id,int bgcolor)
{
        int temp;
        int winid;
        winid=button[id].win;
        rectfill(guiwin[winid].bmp,button[id].x,button[id].y,button[id].x2,button[id].y2,bgcolor);
        button[id].used=0;
        button[id].enabled=0;
        if(button[id].type==2)
                destroy_bitmap(button[id].bmp);               
};

void UnHideWin(int id)
{
        hidden[id].used=0;
        DestroyButton(hidden[id].button,guigray);
        guiwin[hidden[id].win].y=hidden[id].y;
        SetFocusOn(hidden[id].win);
        RefreshDesktop();
};

void HideWindow(int winid)
{
        int temp;
        int row;
        int column;
        row=1;
        column=0;
        temp=0;
        do{
                temp=temp+1;
                if(temp>9){row=2;column=9;}
                if(hidden[temp].used==0)
                {
                        hidden[temp].y=guiwin[winid].y;
                        guiwin[winid].y=screen_h+2;
                        hidden[temp].used=1;
                        hidden[temp].win=winid;
                        strncpy(hidden[temp].caption,guiwin[winid].caption,5);
                        hidden[temp].button=MakeButton(mainwin,((winid-column)*55)+20,5,hidden[temp].caption,UnHideWin,temp);
                        break;
                }

        }while(temp<100);
        RefreshDesktop();
};

int MakeWindow(int x,int y,int w,int h,char *caption,void (*CallBack)(int data),int data)
{
        FONT *font;
        int temp;
	demoteallwins();
        temp=0;
        do{
                temp=temp+1;
                if(guiwin[temp].used==0)
                {
                        guiwin[temp].used=1;
                        guiwin[temp].x=x;
                        guiwin[temp].w=w;
                        guiwin[temp].h=h;
                        guiwin[temp].y=y;
			guiwin[temp].z=0;
                        guiwin[temp].visible=1;
                        guiwin[temp].caption=caption;
                        break;
                }
        }while(temp<MAXWINDOWS);
        font=SystemFont();
        guitrans=makecol(255,0,255);
        guiwhite=makecol(255,255,255);
        guiblue=makecol(108,182,255);
        guigray=makecol(210,210,210);
        guired=makecol(255,0,0);
        guiwin[temp].bmp=create_bitmap(w,h);
        rectfill(guiwin[temp].bmp,0,0,w,h,guigray);
        rect(guiwin[temp].bmp,0,0,w-1,h-1,0);
        line(guiwin[temp].bmp,0,0,w,0,guiwhite);
        line(guiwin[temp].bmp,0,0,0,h,guiwhite);
	//rect(guiwin[temp].bmp,1,1,w-1,h-1,makecol(0,128,255));
	//rect(guiwin[temp].bmp,2,2,w-2,h-2,makecol(0,128,255));
        guiwin[temp].exitbutton=MakeColorButton(temp,w-21,0,20,20,makecol(0,128,255),"X",CallBack,data);
        guiwin[temp].movebutton=MakeColorButton(temp,0,0,w-42,20,makecol(0,128,255),caption,BlankHandler,0);
        guiwin[temp].hidebutton=MakeColorButton(temp,w-42,0,20,20,makecol(0,128,255),"-",HideWindow,temp);
        line(guiwin[temp].bmp,1,20,0,20,w);
        return temp;
}


int MakeButton(int winid,int x,int y,char *caption,void (*CallBack)(int data),int data)
{
        //create a button and retun a handle
        int temp;
        int x2,y2;
        int dummy;
        FONT *font;
        font=SystemFont();
        dummy=0;
        do{
                dummy=dummy+1;
                if(button[dummy].used==0)
                {
                        button[dummy].used=1;
                        button[dummy].x=x;
                        button[dummy].y=y;
                        button[dummy].x2=text_length(SystemFont(),caption)+6+x;
                        button[dummy].y2=y+15;
                        button[dummy].win=winid;
                        button[dummy].type=0;   //regular button
                        button[dummy].color=guigray;
                        button[dummy].caption=caption;
                        button[dummy].enabled=1;
                        button[dummy].data=data;
                        button[dummy].CallBack=CallBack;
                        break;
                }
        }while(dummy<MAXBUTTONS);
        x2=button[dummy].x2;
        y2=button[dummy].y2;
        temp=strlen(caption)*10+2;
        temp=temp/2;
        rectfill(guiwin[winid].bmp,x,y,button[dummy].x2,button[dummy].y2,guigray);
        rect(guiwin[winid].bmp,x,y,button[dummy].x2,button[dummy].y2,0);
        line(guiwin[winid].bmp,x,y,x,button[dummy].y2,guiwhite);
        line(guiwin[winid].bmp,x,y,button[dummy].x2,y,guiwhite);
        textout_centre(guiwin[winid].bmp,font,caption,((x2-x)/2)+x,y+1,0);
        return dummy;
}

void RefreshWin(int winid)
{
        int temp;
	int mx;
	int my;
	int mb;
	BITMAP *bmp;
        if(guiwin[winid].used!=1){return;}
        if(winid==CurrentWindow() || winid==mainwin)
        {
		bmp=create_bitmap(guiwin[winid].w,guiwin[winid].h);
                blit(guiwin[winid].bmp,bmp,0,0,0,0,guiwin[winid].w,guiwin[winid].h);
		getmouse(&mx,&my,&mb);
		if(MouseOver(winid)==1)
		{
			blit(bmp,mousebuff,mx-guiwin[winid].x,my-guiwin[winid].y,0,0,20,20);
			masked_blit(mouse,bmp,0,0,mx-guiwin[winid].x,my-guiwin[winid].y,20,20);
		}else if(mx+20>=guiwin[winid].x && mx<=guiwin[winid].x)
		{
			blit(bmp,mousebuff,0,my-guiwin[winid].y,guiwin[winid].x-mx,0,20,20);
			masked_blit(mouse,bmp,0,0,mx-guiwin[winid].x,my-guiwin[winid].y,20,20);
		}else if(my+20>=guiwin[winid].y && my<=guiwin[winid].y)
		{
			//blit(bmp,mousebuff,0,0,guiwin[winid].x-mx,guiwin[winid].y-my,20,20);
			blit(bmp,mousebuff,mx-guiwin[winid].x,0,0,guiwin[winid].y-my,20,20);
			masked_blit(mouse,bmp,0,0,mx-guiwin[winid].x,my-guiwin[winid].y,20,20);
		}
                blit(bmp,screen,0,0,guiwin[winid].x,guiwin[winid].y,guiwin[winid].w,guiwin[winid].h);
		destroy_bitmap(bmp);
		return;
        }
	RefreshDesktop();
	return;

}

BITMAP *GetWinBMP(int winid)
{
        return guiwin[winid].bmp;
}

void ShowWin(int winid)
{
        guiwin[winid].visible=1;
        SetFocusOn(winid);
        RefreshWin(winid);
};

void DisableButton(int butid)
{
        button[butid].enabled=0;
};

void EnableButton(int butid)
{
        button[butid].enabled=1;
};

int IsPressed(int butid)
{
        //returns 1 if button pressed, 0 otherwise
        int temp;
        int mx;
        int my;
        int mb;
        int x;
        int y;
        int x2;
        int y2;
        if(button[butid].used!=1){return 0;}
        x=button[butid].x;
        y=button[butid].y;
        x2=button[butid].x2;
        y2=button[butid].y2;
        temp=button[butid].win;
        x=x+guiwin[temp].x;
        y=y+guiwin[temp].y;
        x2=x2+guiwin[temp].x;
        y2=y2+guiwin[temp].y;
        getmouse(&mx,&my,&mb);
        if(mb!=0 && mx>x && mx<x2 && my>y && my<y2 && button[butid].enabled==1)
        {
                lastmb=mb;
                return 1;
        }
        return 0;
};

int MakeColorButton(int winid,int x,int y,int w,int h,int c,char *caption,void (*CallBack)(int data),int data)
{
        //create a button and retun a handle
        int temp;
        int dummy;
        dummy=0;
        do{
                dummy=dummy+1;
                if(button[dummy].used==0)
                {
                        button[dummy].used=1;
                        button[dummy].x=x;
                        button[dummy].y=y;
                        button[dummy].x2=x+w;
                        button[dummy].y2=y+h;
                        button[dummy].win=winid;
                        button[dummy].type=1;   //color special button
                        button[dummy].color=c;
                        button[dummy].caption=caption;
                        button[dummy].enabled=1;
                        button[dummy].CallBack=CallBack;
                        button[dummy].data=data;
                        break;
                }
        }while(dummy<MAXBUTTONS);
        temp=strlen(caption)*10+2;
        temp=temp/2;
        rectfill(guiwin[winid].bmp,x,y,button[dummy].x2,button[dummy].y2,c);
        rect(guiwin[winid].bmp,x,y,button[dummy].x2,button[dummy].y2,0);
        line(guiwin[winid].bmp,x,y,x,button[dummy].y2,guiwhite);
        line(guiwin[winid].bmp,x,y,button[dummy].x2,y,guiwhite);
        textout_centre(guiwin[winid].bmp,monofont,caption,(w/2)+x+1,(h/2)+y-8,guiwhite);
        return dummy;
};

int MakeLabelButton(int winid,FONT *f,int x,int y,int c,char *caption,void (*CallBack)(int data),int data)
{
        //create a button and retun a handle
        int temp;
        int dummy;
        FONT *font;
        font=SystemFont();
        dummy=0;
        do{
                dummy=dummy+1;
                if(button[dummy].used==0)
                {
                        button[dummy].used=1;
                        button[dummy].x=x;
                        button[dummy].y=y;
                        //button[dummy].x2=x+(strlen(caption)*11)+2;
			button[dummy].x2=x+text_length(f,caption);
                        button[dummy].y2=y+f->height;
                        button[dummy].win=winid;
                        button[dummy].type=3;   //icon special button
                        button[dummy].color=c;
                        button[dummy].enabled=1;
                        button[dummy].caption=caption;
                        button[dummy].CallBack=CallBack;
                        button[dummy].data=data;
                        break;
                }
        }while(dummy<MAXBUTTONS);
        temp=strlen(caption)*11+2;
        temp=temp/2;
        textout(guiwin[winid].bmp,f,caption,x,y,c);
        return dummy;
};

int MakeIcon(int winid,int x,int y,char *filename,char *caption,void(*CallBack)(int data),int data)
{
        //create a button and retun a handle
        int temp;
        BITMAP *tempbmp;
        int dummy;
        FONT *font;
        font=SystemFont();
        dummy=0;
        do{
                dummy=dummy+1;
                if(button[dummy].used==0)
                {
                        button[dummy].bmp=load_bitmap(filename,0);
                        tempbmp=button[dummy].bmp;
                        button[dummy].used=1;
                        button[dummy].x=x;
                        button[dummy].y=y;
                        button[dummy].x2=tempbmp->w+x;
                        button[dummy].y2=y+tempbmp->h;
                        button[dummy].win=winid;
                        button[dummy].type=2;   //color special button
                        button[dummy].color=guigray;
                        button[dummy].enabled=1;
                        button[dummy].caption=caption;
                        button[dummy].CallBack=CallBack;
                        button[dummy].data=data;
                        break;
                }
        }while(dummy<MAXBUTTONS);
        temp=text_length(SystemFont(),caption);
        temp=temp/2;
        masked_blit(button[dummy].bmp,guiwin[winid].bmp,0,0,x,y,tempbmp->w,tempbmp->h);
        if(temp>0)
        {
                //rectfill(guiwin[winid].bmp,x-temp-2+(tempbmp->w/2),y+tempbmp->h,x+temp+1+(tempbmp->w/2),y+tempbmp->h+2+10,guiblue);
                textout_centre(guiwin[winid].bmp,font,caption,x+(tempbmp->w/2),y+tempbmp->h,0);
        }
        return dummy;
};

void SetFocusOn(int thiswin){
        int temp;
	int cnt;
	cnt=0;
        temp=0;
	//guiwin[thiswin].z=0;
	do{
		if(guiwin[temp].z==1)
			break;
		if(temp==MAXWINDOWS)
		{
			do{
				if(guiwin[cnt].z==0 && guiwin[cnt].used==1)
				{
					guiwin[cnt].z=1;
					guiwin[thiswin].z=0;
					return;
				}
				cnt++;
				if(cnt>MAXWINDOWS)
					break;
			}while(1);
			guiwin[thiswin].z=0;
			return;
		}
		temp++;
	}while(1);
	demoteallwins();
	guiwin[thiswin].z=0;
};

int MouseOver(int winid)
{
        int mb,mx,my;
        int x,y,x2,y2;
        int temp;

        getmouse(&mx,&my,&mb);
        x=guiwin[winid].x;
        y=guiwin[winid].y;
        x2=guiwin[winid].w+x;
        y2=guiwin[winid].h+y;
        if(mx>x && mx<x2 && my>y && my<y2)
        {
                return 1;
        }
        return 0;
};

int CurrentWindow()
{
        int temp;
        temp=0;
        do{
                temp=temp+1;
                if(guiwin[temp].used==1 && guiwin[temp].z==0)
                {
                        return temp;
                }
        }while(temp<MAXWINDOWS);
        return 0;
};

int getzwin(int z)
{
	int cnt;
	cnt=0;
	do{
		if(guiwin[cnt].z==z && guiwin[cnt].used==1)
			return cnt;
		cnt++;
		if(cnt>MAXWINDOWS)
			return (-1);
	}while(1);
}

void RefreshDesktop(){
        int temp;
        int x,y,b;
	int cur;
	int mx;
	int my;
	int mb;
        BITMAP *bmp;
        scare_mouse();
        bmp=create_bitmap(screen_w,screen_h);
        blit(wallpaper,bmp,0,0,0,0,wallpaper->w,wallpaper->h);
        temp=MAXZ+1;
        do{
                temp--;
		cur=getzwin(temp);
		if(cur!=(-1))
blit(guiwin[cur].bmp,bmp,0,0,guiwin[cur].x,guiwin[cur].y,guiwin[cur].w,guiwin[cur].h);
        }while(temp>0);
        temp=CurrentWindow();
        blit(guiwin[temp].bmp,bmp,0,0,guiwin[temp].x,guiwin[temp].y,guiwin[temp].w,guiwin[temp].h);
        blit(bmp,screen,0,0,0,0,bmp->w,bmp->h);
        unscare_mouse();
        destroy_bitmap(bmp);
};

void MoveWin(int winid){
        int mb,mx,my;
        int x,y;
        int ox,oy,ox2,oy2;
        int temp;
        BITMAP *screenbuffer;
        RefreshWin(winid);
        x=guiwin[winid].x;
        y=guiwin[winid].y;
        GetScreenRes(&screen_w,&screen_h);
        screenbuffer=create_bitmap(screen_w,screen_h);
        scare_mouse();
        blit(screen,screenbuffer,0,0,0,0,screen_w,screen_h);
        unscare_mouse();
        getmouse(&mx,&my,&mb);
        ox=mx-x;
        oy=my-y;
        do{
                getmouse(&mx,&my,&mb);
                ox2=mx-ox;
                oy2=my-oy;
                if(mb==0){break;}
                rect(screen,ox2,oy2,guiwin[winid].w+ox2,guiwin[winid].h+oy2,guiwhite);
                blit(screenbuffer,screen,0,0,0,0,screen_w,screen_h);
        }while(mb!=0);
        destroy_bitmap(screenbuffer);
	if(oy2>(screen_h-50))
		oy2=screen_h-50;
        guiwin[winid].x=ox2;
        guiwin[winid].y=oy2;
        RefreshDesktop();
};

void CheckAllEditBoxes(int winid)
{
        int mx;
        int my;
        int mb;
        int x,y,x2,y2;
        int temp;
        int temp2;
        int scan;
	int scancode;
        int pointer;
        if(winid==0){return;}
        if(guiwin[winid].used!=1){return;}
        getmouse(&mx,&my,&mb);
        if(mb==1 && guiwin[winid].z==0)
        {
                temp=0;
                do{
                        temp=temp+1;
                        if(editbox[temp].win==winid && editbox[temp].used==1)
                        {
                                x=editbox[temp].x;
                                y=editbox[temp].y;
                                x2=editbox[temp].x2;
                                y2=editbox[temp].y2;
                                x=x+guiwin[winid].x;
                                y=y+guiwin[winid].y;
                                x2=x2+guiwin[winid].x;
                                y2=y2+guiwin[winid].y;
                                if(mb==1 && mx>x && mx<x2 && my>y && my<y2)
                                {
                                        editbox[temp].hasfocus=1;
                                        if(strlen(editbox[temp].text)>0)
                                                editbox[temp].pointer=strlen(editbox[temp].text);
                                        RefreshEditBox(temp);
                                }
                                else
                                {
                                        editbox[temp].hasfocus=0;
                                        RefreshEditBox(temp);
                                }
                        }
                }while(temp<MAXEDITBOXES);
                RefreshWin(winid);
                return;
        }
        key=0;
        if(keypressed()){key=readkey();}
        temp=0;
        do{
                temp=temp+1;
                if(editbox[temp].used==1 && editbox[temp].hasfocus==1 && editbox[temp].win==winid)
                {
                        if(key!=0)
                        {
                                scan=(key & 0xff);
				scancode==(key >> 8);
                                pointer=editbox[temp].pointer;
                                if(scan==8 && pointer>0)//backspace
                                {
                                        editbox[temp].pointer=editbox[temp].pointer-1;
                                        pointer=editbox[temp].pointer;
                                        editbox[temp].text[pointer]=0;
                                        RefreshEditBox(temp);
                                        RefreshWin(winid);
                                }
                                else if(scan!=8 && scan!=0x0a && scan!=0x0d)
                                {
                                        editbox[temp].text[pointer]=scan;
                                        editbox[temp].pointer=editbox[temp].pointer+1;
                                        RefreshEditBox(temp);
                                        RefreshWin(winid);
                                }
				else if(scan==0x0d && editbox[temp].CallBack!=0)
				{
					editbox[temp].CallBack(editbox[temp].data);
					break;
				}
                        };
                        break;
                }
        }while(temp<MAXEDITBOXES);
};

void CheckAllDesktopIcons()
{
        int temp;
        int x,y,x2,y2,mx,my,mb;
        //first make sure mouse is not over a window!
        temp=0;
        do{
                temp=temp+1;
                if(guiwin[temp].used==1 && MouseOver(temp)==1){return;}
        }while(temp<MAXWINDOWS);
        temp=0;
        getmouse(&mx,&my,&mb);
        if(mb==0){return;}
	lastmb=mb;
        do{
                temp=temp+1;
                if(icon[temp].used && icon[temp].CallBack!=0)
                {
                        x=icon[temp].x;
                        y=icon[temp].y;
                        x2=icon[temp].x2;
                        y2=icon[temp].y2;
                        if(mx>x && mx<x2 && my>y && my<y2)
                        {
                                //do the icon callback then return for other events
                                do{
                                        getmouse(&mx,&my,&mb);
                                }while(mb!=0);
                                icon[temp].CallBack(icon[temp].data);
                                return;
                        }
                }
        }while(temp<MAXICONS);
};

void *GUI_Events(int data)
{
        //checks for move button clicks
        int temp;
        int curwin;
        int tempbut;
        int movebutton;
        int mx,my,mb;
	int cnt;
	int zwin;
        
        curwin=CurrentWindow();
	getmouse(&mx,&my,&mb);
	lastmb=mb;
	if(mb==1)
	{
		int cnt=0;
		do{
			if(guiwin[cnt].ismenu==1 && MouseOver(cnt)==0 && mb==1)
				CloseWin(cnt);
			cnt++;
			if(cnt>MAXWINDOWS)
				break;
		}while(1);
	}
        temp=0;
	if(mb!=0)
	{
        do{
                temp=temp+1;
                if(guiwin[temp].used==1)
                {
                        movebutton=guiwin[temp].movebutton;
                        tempbut=IsPressed(movebutton);
                        if(tempbut==1)
                        {
                                //we can move this window
                                if(guiwin[temp].z==0)
                                {
                                        MoveWin(temp);
                                        SetFocusOn(temp);
                                        RefreshWin(temp);
                                        break;
                                }
                                else
                                {
                                        if(MouseOver(curwin)==0)
                                        {
                                                SetFocusOn(temp);
                                                RefreshDesktop();
                                                break;
                                        }
                                }
                        }
                        getmouse(&mx,&my,&mb);
			cnt=1;			
			do{
				zwin=getzwin(cnt);
				if(zwin!=(-1) && MouseOver(curwin)==0 && MouseOver(zwin)==1 && mb!=0 && tempbut!=1)
				{
	                                SetFocusOn(zwin); RefreshDesktop();
	                                goto DONEWINS;
	                        }
				cnt++;
				if(cnt>MAXZ)
					break;
			}while(1);
                }
        }while(temp<MAXWINDOWS);
	}
DONEWINS:
        CheckAllTextBoxes(CurrentWindow());
        CheckAllEditBoxes(CurrentWindow());
        CheckAllButtons(CurrentWindow());
        CheckAllDesktopIcons(CurrentWindow());
        CheckAllListBoxes(CurrentWindow());
        GenEvent(GUI_Events,0);
};

void CloseWin(int winid)
{
        int temp;
	int cnt;
        if(guiwin[winid].used==0){return;}
        guiwin[winid].used=0;
        guiwin[winid].visible=0;
	guiwin[winid].ismenu=0;
        destroy_bitmap(guiwin[winid].bmp);
        temp=0;
        do{
                temp=temp+1;
                if(button[temp].win==winid)
                {
                        button[temp].used=0;
                        button[temp].enabled=0;
                }
        }while(temp<MAXBUTTONS);

        temp=0;
        do{
                temp=temp+1;
                if(editbox[temp].win==winid && editbox[temp].used==1)
                {
                        editbox[temp].used=0;
                        editbox[temp].hasfocus=0;
			destroy_bitmap(editbox[temp].bmp);
                }
        }while(temp<MAXEDITBOXES);

        temp=0;
        do{
                temp=temp+1;
                if(textbox[temp].win==winid && textbox[temp].used==1)
                {
                        textbox[temp].used=0;
                        textbox[temp].hasfocus=0;
                        destroy_bitmap(textbox[temp].bmp);
                }
        }while(temp<MAXTEXTBOXES);


        temp=0;
        do{
                temp=temp+1;
                if(listbox[temp].win==winid && listbox[temp].used==1)
                {
                        listbox[temp].used=0;
                        strcpy(listbox[temp].selection,"");
                        free((void *)listbox[temp].text);
                }
        }while(temp<MAXLISTBOXES);
        
        //now find a new window to set focus on
	cnt=0;
	do{
		if(guiwin[cnt].z==0 && guiwin[cnt].used==1)
			break;
		cnt++;
		if(cnt==MAXWINDOWS)
		{
			promoteallwins();
			break;
		}
	}while(1);
	cnt=0;
	temp=0;
	do{
		temp=getzwin(cnt);
		if(temp!=(-1))
		{
			SetFocusOn(temp);
			break;
		}
		cnt++;
		if(cnt>MAXZ)
			break;
	}while(1);
	RefreshDesktop();
};

void SetWallpaper(char *filename)
{
        char temp[4];
	BITMAP *tempbmp;
        strcpy(temp,filename+strlen(filename)-2);
        memset(wallpaperfilename,0,sizeof(wallpaperfilename));
        strcpy(wallpaperfilename,filename);
	wallpaper=create_bitmap(screen_w,screen_h);
        tempbmp=load_bitmap(wallpaperfilename,0);
	stretch_blit(tempbmp,wallpaper,0,0,tempbmp->w,tempbmp->h,0,0,wallpaper->w,wallpaper->h);
	destroy_bitmap(tempbmp);
        /*if(strncmp(strupr(temp),"JPG",3)!=1)
        {
                wallpaper=load_bitmap(filename,0);
        }
        else{
                wallpaper=load_jpg(filename,0);
        }*/
        RefreshDesktop();
};

void RefreshEditBox(int boxid)
{
	BITMAP *bmp;
        int winid;
        int temp;
        if(editbox[boxid].used!=1){return;}
	bmp=editbox[boxid].bmp;
        winid=editbox[boxid].win;
        rectfill(editbox[boxid].bmp,0,0,bmp->w,bmp->h,guiwhite);
	textout(editbox[boxid].bmp,SystemFont(),editbox[boxid].text,2,2,0);
	blit(editbox[boxid].bmp,guiwin[winid].bmp,0,0,editbox[boxid].x,editbox[boxid].y,editbox[boxid].x2,editbox[boxid].y2);

        if(editbox[boxid].hasfocus!=1)
        {
                rect(guiwin[winid].bmp,editbox[boxid].x,editbox[boxid].y,editbox[boxid].x2,editbox[boxid].y2,0);
        }
        else
        {

                rect(guiwin[winid].bmp,editbox[boxid].x,editbox[boxid].y,editbox[boxid].x2,editbox[boxid].y2,guiblue);
        }
};

int AddEditBox(int winid,int x,int y,int w,char *textstring,void (*CallBack)(int data),int data)
{
        int temp;
        temp=0;
        do{
                temp=temp+1;
                if(editbox[temp].used==0)
                {
                        editbox[temp].used=1;
                        editbox[temp].x=x;
                        editbox[temp].y=y;
                        editbox[temp].x2=x+w;
                        editbox[temp].y2=y+16;
                        editbox[temp].text=textstring;
                        editbox[temp].hasfocus=0;
                        editbox[temp].pointer=0;
                        editbox[temp].win=winid;
			editbox[temp].data=data;
			editbox[temp].CallBack=CallBack;
			editbox[temp].bmp=create_bitmap(w,16);
                        break;
                }
        }while(temp<MAXEDITBOXES);
        rectfill(guiwin[winid].bmp,x,y,editbox[temp].x2,editbox[temp].y2,guiwhite);
        rect(guiwin[winid].bmp,x,y,editbox[temp].x2,editbox[temp].y2,0);
        RefreshWin(winid);
        return temp;
};

int AddDesktopIcon(int x,int y,char *filename,char *caption,void(*CallBack)(int data),int data)
{
        //create an icon and retun a handle
        int temp;
        BITMAP *tempbmp;
        int dummy;
        FONT *font;
        font=SystemFont();
        dummy=0;
        do{
                dummy=dummy+1;
                if(icon[dummy].used==0)
                {
                        icon[dummy].bmp=load_bitmap(filename,0);
                        tempbmp=icon[dummy].bmp;
                        icon[dummy].used=1;
                        icon[dummy].x=x;
                        icon[dummy].y=y;
                        icon[dummy].x2=tempbmp->w+x;
                        icon[dummy].y2=y+tempbmp->h;
                        icon[dummy].enabled=1;
                        icon[dummy].caption=caption;
                        icon[dummy].CallBack=CallBack;
                        icon[dummy].data=data;
			icon[dummy].type=1;	//its a desktop icon
                        break;
                }
        }while(dummy<101);
        temp=text_length(SystemFont(),caption);
        temp=temp/2;
        masked_blit(icon[dummy].bmp,wallpaper,0,0,x,y,tempbmp->w,tempbmp->h);
        if(temp>0)
        {
                //rectfill(wallpaper,x-temp-2+(tempbmp->w/2),y+tempbmp->h,x+temp+1+(tempbmp->w/2),y+tempbmp->h+2+10,guiblue);
                textout_centre(wallpaper,font,caption,x+(tempbmp->w/2)+1,y+tempbmp->h+1,0);
                textout_centre(wallpaper,font,caption,x+(tempbmp->w/2),y+tempbmp->h,makecol(255,255,255));
        }
        return dummy;
};

void EraseIcon(int id)
{
        icon[id].used=0;
        destroy_bitmap(icon[id].bmp);
        RefreshIcons();
};

void RefreshIcons()
{
        int dummy;
        int temp;
        int x,y;
        FONT *font;
        char *caption;
        BITMAP *tempbmp;

        destroy_bitmap(wallpaper);
	temp=0;
	do{
		temp++;
		if(icon[temp].used==1 && icon[temp].type==1)
		{
			icon[temp].used=0;
			destroy_bitmap(icon[temp].bmp);
		}
		if(temp>MAXICONS)
			break;
	}while(1);
	initdesktop();
	RefreshDesktop();
	return;


        destroy_bitmap(wallpaper);
	wallpaper=create_bitmap(screen_w,screen_h);
        tempbmp=load_bitmap(wallpaperfilename,0);
	stretch_blit(tempbmp,wallpaper,0,0,tempbmp->w,tempbmp->h,0,0,wallpaper->w,wallpaper->h);
	destroy_bitmap(tempbmp);
        font=SystemFont();

        dummy=0;
        do{
                dummy=dummy+1;
                if(dummy==MAXICONS)
                        break;
                if(icon[dummy].used==1)
                {
                        tempbmp=icon[dummy].bmp;
                        caption=icon[dummy].caption;
                        x=icon[dummy].x;
                        y=icon[dummy].y;
                        temp=text_length(font,caption);
                        temp=temp/2;
                        masked_blit(icon[dummy].bmp,wallpaper,0,0,x,y,tempbmp->w,tempbmp->h);
                        if(temp>0)
                        {
                                rectfill(wallpaper,x-temp-2+(tempbmp->w/2),y+tempbmp->h,x+temp+1+(tempbmp->w/2),y+tempbmp->h+2+10,guiblue);
                                textout_centre(wallpaper,font,caption,x+(tempbmp->w/2),y+tempbmp->h,0);
                        }
                }
        }while(1);
        RefreshDesktop();
};

void ResetWallpaper(char *filename)
{
	BITMAP *tempbmp;
        destroy_bitmap(wallpaper);
        memset(wallpaperfilename,0,sizeof(wallpaperfilename));
        strcpy(wallpaperfilename,filename);
	wallpaper=create_bitmap(screen_w,screen_h);
        tempbmp=load_bitmap(wallpaperfilename,0);
	stretch_blit(tempbmp,wallpaper,0,0,tempbmp->w,tempbmp->h,0,0,wallpaper->w,wallpaper->h);
	destroy_bitmap(tempbmp);
        RefreshIcons();
};

void *GetCallBackAddress(int butid)
{
        return *button[butid].CallBack;

};

void CheckAllButtons(int winid)
{
        int temp;
        int mx,my,mb;
        int x,x2,y2,y;
        getmouse(&mx,&my,&mb);
        if(mb==0){return;}
        void (*CallBack)();
        if(CurrentWindow()!=winid)
        {
                return;
        }
        if(winid==0){return;}
        temp=0;
        do{
                temp=temp+1;
                if(button[temp].win==winid && IsPressed(temp)==1 && button[temp].CallBack!=0)
                {
                        x=button[temp].x+guiwin[winid].x;
                        x2=button[temp].x2+guiwin[winid].x;
                        y=button[temp].y+guiwin[winid].y;
                        y2=button[temp].y2+guiwin[winid].y;
                        rect(screen,x,y,x2,y2,guiblue);
                        if(temp!=guiwin[winid].movebutton)
                        {
                                do{
                                        getmouse(&mx,&my,&mb);
                                }while(mb!=0);
                        }
                        RefreshWin(winid);
                        LastButton=temp;
                        CallBack=GetCallBackAddress(temp);
                        CallBack(button[temp].data);
                }
        }while(temp<MAXBUTTONS);
};

void RestartEvents()
{
        GenEvent(GUI_Events,0);
	GenEvent(GUI_time,0);
};

void InitGUI()
{
        GetScreenRes(&screen_w,&screen_h);
};

void BlankHandler()
{
        return;
};

