#include <ikondcm.h>
#include <ikonall.h>
//Header file to make an Ikon application.

//defines for GUI interface.
#define nouse __attribute__((unused))

#define FBYTE     1             /* unsigned char  */
#define FSHORT    2             /* short  */
#define FINT      3             /* int  */
#define FLONG     4             /* long  */
#define FSTRING   5             /* char*   */
#define FPTRSTR   6             /* char**  */
#define FPOINTS   7
#define FBPOINTS  8
#define FFLOAT    9
#define FHEX1     10            /* 1-byte value  */
#define FHEX2     11            /* 2-byte value  */
#define FHEX4     12            /* 4-byte value  */
#define FOCT1     13            /* 1-digit view 4-byte value */
#define FOCT2     14            /* 2-digit view 4-byte value  */
#define FOCT3     15            /* 3-digit view 4-byte value  */
#define FOCT4     16            /* 4-digit view 4-byte value  */
#define FNAME     0x20
#define FBLANK0   0x40
#define FUNDEF    0x6000
#define B_UNDEF_VAL 0xFF
#define S_UNDEF_VAL 0x8000
#define I_UNDEF_VAL 0x80000000L
#define L_UNDEF_VAL 0x80000000L
#define P_UNDEF_VAL 0x8000
#define BP_UNDEF_VAL 0x80


#define CT_BORDER       1
#define CT_OBJECT_TABLE 2
#define IMAGE_BMP       0
#define IMAGE_TRANS_BMP 1
#define IMAGE_RLE_SPRITE 2
#define IMAGE_CMP_SPRITE 3
#define LEFT_MOUSE      1 /* mouse button values in calls to below */
#define RIGHT_MOUSE     2

#define K_GenEvent              0
#define K_ExitApp               1
#define K_SystemFont            2
#define K_GetScreenRes          3
#define K_ShutDown              4
#define K_ReadKey               5
#define K_KeyPressed            6
#define K_Scancodetoascii       7
#define K_text_length           8
#define K_text_height           9
#define K_masked_stretch_blit   10
#define K_DoEvents              11
#define K_socket_byte           14
#define K_getdisk               15
#define K_load_gif              21
#define K_save_gif              22
#define K_algif_load_animation  23
#define K_copyfile              29

//30 is next free one
#define K_RunApp                138
#define K_Load_Jpg              164
#define K_Save_Jpg              165
#define K_sprintf              173
//*********DLL FUNCTIONS********************
#define K_Load_DLL              169
#define K_Unload_DLL            170
#define K_Get_DLL_Function      171
#define K_GetPath               175
#define K_Scare_Mouse           176
#define K_UnScare_Mouse         177
//*********ALLEGRO FUNCTIONS****************
#define K_GetScreen             139
#define K_Line                  140
#define K_GetMouse              141
#define K_RectFill              142
#define K_Rect                  143
#define K_Circle                144
#define K_CircleFill            145
#define K_MakeCol               146
#define K_GetPixel              147
#define K_FloodFill             148
#define K_Load_Bitmap           149
#define K_Save_Bitmap           150
#define K_Blit                  151
#define K_Destroy_Bitmap        152
#define K_PutPixel              153
#define K_Create_Bitmap         154
#define K_TextOut               156
#define K_TextOut_Centre        157
#define K_Draw_Sprite           159
#define K_Masked_Blit           160
#define K_Set_Clip              161
#define K_TextPrintf            164
#define K_TextPrintf_Centre     165
#define K_set_volume            24
#define K_load_sample           25
#define K_destroy_sample        26
#define K_play_sample           27
#define K_adjust_sample         28

struct DWORDREGS {
  unsigned long edi;
  unsigned long esi;
  unsigned long ebp;
  unsigned long cflag;
  unsigned long ebx;
  unsigned long edx;
  unsigned long ecx;
  unsigned long eax;
  unsigned short eflags;
};

struct DWORDREGS_W {
  unsigned long di;
  unsigned long si;
  unsigned long bp;
  unsigned long cflag;
  unsigned long bx;
  unsigned long dx;
  unsigned long cx;
  unsigned long ax;
  unsigned short flags;
};

struct WORDREGS {
  unsigned short di, _upper_di;
  unsigned short si, _upper_si;
  unsigned short bp, _upper_bp;
  unsigned short cflag, _upper_cflag;
  unsigned short bx, _upper_bx;
  unsigned short dx, _upper_dx;
  unsigned short cx, _upper_cx;
  unsigned short ax, _upper_ax;
  unsigned short flags;
};

struct BYTEREGS {
  unsigned short di, _upper_di;
  unsigned short si, _upper_si;
  unsigned short bp, _upper_bp;
  unsigned long cflag;
  unsigned char bl;
  unsigned char bh;
  unsigned short _upper_bx;
  unsigned char dl;
  unsigned char dh;
  unsigned short _upper_dx;
  unsigned char cl;
  unsigned char ch;
  unsigned short _upper_cx;
  unsigned char al;
  unsigned char ah;
  unsigned short _upper_ax;
  unsigned short flags;
};

union REGS {		/* Compatible with DPMI structure, except cflag */
  struct DWORDREGS d;
#ifdef _NAIVE_DOS_REGS
  struct WORDREGS x;
#else
#ifdef _BORLAND_DOS_REGS
  struct DWORDREGS x;
#else
  struct DWORDREGS_W x;
#endif
#endif
  struct WORDREGS w;
  struct BYTEREGS h;
};

BITMAP *screen;

void (*DoEvents)();
void (*GenEvent)(void *(CallBack)(int data),int data);
void (*ExitApp)(int threadid);
int (*RunApp)(char *appfilename);
FONT *(*SystemFont)(void);
char (*sprintf)(char *str,const char *format, ...);
char *(*GetCommand)(int id);
void (*ShutDown)();
void (*GetScreenRes)(int *w,int *h);
BITMAP *(*getmousebuffer)(void);
void (*PutClipboard)(char *data,int len);
char *(*GetClipboard)(void);
void (*_go32_dpmi_lock_code)( void *lockaddr, unsigned long locksize);
void (*_go32_dpmi_lock_data)( void *lockaddr, unsigned long locksize);
//**********WATTCP STUFF******************
void (*socket_send_byte)(int id,char c);
void (*socket_send)(int id,char *buff,int numbytes);
int (*socket_recieve)(int id,char *buff,int num);
void (*socket_close)(int id);
int (*socket_connect)(int id,char *ipaddress,int port);
int (*socket_bind)(int id,char *ipaddress,int port);
int (*socket_listen)(int id);
int (*socket_accept)(int id);
int (*socket_select)(int id,int usecdelay);
int (*socket_bind)(int id,char *ipaddr,int port);
//********DYNAMIC LINK LIBRARY (DLL) FUNCTIONS***********
int (*Load_DLL)(char *filename);
void (*Unload_DLL)(int handle);
void *(*Get_DLL_Function)(int handle,int function);
void (*Register_Device)(int handle,char *devicename);
int (*Get_Device_Handle)(char *devicename);
int (*socket_open)(void);
float (*GetIkonVersion)(void);
//******TTF***********************
#define ALLEGTTF_NOSMOOTH    0
#define ALLEGTTF_TTFSMOOTH   1
#define ALLEGTTF_REALSMOOTH  2
FONT* (*load_ttf_font)(const char* filename, const int points, const int smooth);
void (*destroy_font)(FONT *fnt);

//******ALLEGRO FUNCTIONS*********
#define END_OF_FUNCTION(x)          void x##_end(void) { }
#define END_OF_STATIC_FUNCTION(x)   static void x##_end(void) { }
#define LOCK_DATA(d, s)             _go32_dpmi_lock_data((void *)d, s)
#define LOCK_CODE(c, s)             _go32_dpmi_lock_code((void *)c, s)
#define LOCK_VARIABLE(x)            LOCK_DATA((void *)&x, sizeof(x))
#define LOCK_FUNCTION(x)            LOCK_CODE((void *)x, (long)x##_end - (long)x)
BITMAP *(*load_gif)(const char *filename,RGB *pal);
int (*save_gif)(const char *filename,BITMAP *bmp,RGB *pal);
int (*algif_load_animation)(const char *filename,BITMAP ***frames,int **duration);
void (*masked_stretch_blit)(BITMAP *src,BITMAP *dest,int src_x,int src_y,int src_w,int src_h,int dest_x,int dest_y,int dest_w,int dest_h);
int (*text_length)(const FONT *f,const char *str);
int (*text_height)(const FONT *f);
int (*scancode_to_ascii)(int scancode);
int (*keypressed)();
int (*readkey)();
BITMAP *(*getscreen)(void);
void (*get_mouse_mickeys)(int *mickeyx, int *mickeyy);
void (*clear_to_color)(BITMAP *bitmap, int color);
void (*line)(BITMAP *bmp,int x,int y,int x2,int y2,int col);
void (*getmouse)(int *mousex,int *mousey,int *mouseb);
void (*rectfill)(BITMAP *bmp,int x,int y,int x2,int y2,int color);
void (*rect)(BITMAP *bmp,int x,int y,int x2,int y2,int color);
void (*circle)(BITMAP *bmp,int x,int y,int radius,int color);
void (*circlefill)(BITMAP *bmp,int x,int y,int radius,int color);
int (*makecol)(int r,int g,int b);
int (*getpixel)(BITMAP *bmp,int x,int y);
void (*floodfill)(BITMAP *bmp,int x,int y,int color);
BITMAP *(*load_bitmap)(const char *filename,RGB *pal);
void (*save_bitmap)(const char *filename,BITMAP *bmp);
void (*blit)(BITMAP *source,BITMAP *dest,int source_x,int source_y,int dest_x,int dest_y,int width,int height);
void (*destroy_bitmap)(BITMAP *bmp);
void (*putpixel)(BITMAP *bmp,int x,int y,int color);
BITMAP *(*create_bitmap)(int width,int height);
void (*textout)(BITMAP *bmp,FONT *f,const char *s,int x,int y,int color);
void (*textout_centre)(BITMAP *bmp,FONT *f,const char *s,int x,int y,int color);
void (*draw_sprite)(BITMAP *bmp,BITMAP *sprite,int x,int y);
void (*masked_blit)(BITMAP *source,BITMAP *dest,int source_x,int source_y,int dest_x,int dest_y,int width,int height);
void (*set_clip)(BITMAP *bitmap,int x1,int y1,int x2,int y2);
void (*textprintf)(BITMAP *bmp,const FONT *f,int x,int y,int color,const char *fmt,...);
void (*textprintf_centre)(BITMAP *bmp,const FONT *f,int x,int y,int color,const char *fmt,...);
BITMAP *(*load_jpg)(char *filename,RGB *pallette);
int (*save_jpg)(char *filename,BITMAP *image,RGB *palette);
void (*scare_mouse)();
void (*unscare_mouse)();
BITMAP *(*create_sub_bitmap)(BITMAP *parent,int x,int y,int w,int h);
void (*triangle)(BITMAP *bmp,int x1,int y1,int x2,int y2,int x3,int y3,int color);
void (*rotate_sprite)(BITMAP *bmp,BITMAP *sprite,int x,int y,int angle);
void (*stretch_sprite)(BITMAP *bmp,BITMAP *sprite,int x,int y,int w,int h);
void (*stretch_blit)(BITMAP *src,BITMAP *dest,int src_x,int src_y,int src_w,int src_h,int dest_x,int dest_y,int dest_w,int dest_h);
void (*set_volume)(int dv,int mv);
SAMPLE *(*load_sample)(const char *filename);
void (*destroy_sample)(SAMPLE *spl);
int (*play_sample)(const SAMPLE *spl,int vol,int pan,int freq,int loop);
void (*adjust_sample)(const SAMPLE *spl,int vol,int pan,int freq,int loop);
int (*install_int)(void (*proc)(),int speed);
void (*remove_int)(void (*proc)());
//********************  defines for stdio  ************
#define BUFSIZ          16384
#define EOF             (-1)
#define FILENAME_MAX    260
#define FOPEN_MAX       20
#define L_tmpnam        260
#define NULL            0
#define TMP_MAX         999999
#define FA_RDONLY 1
#define FA_HIDDEN 2
#define FA_SYSTEM 4
#define FA_LABEL 8
#define FA_DIREC 16
#define FA_ARCH 32

#define S_IWUSR         00200

typedef int		dev_t;
typedef int		ino_t;
typedef int		mode_t;
typedef int		nlink_t;
typedef int		gid_t;
typedef int		uid_t;
typedef unsigned int	off_t;
typedef unsigned int time_t;

#define SEEK_SET        0
#define SEEK_CUR        1
#define SEEK_END        2

struct time {
  unsigned char ti_min;
  unsigned char ti_hour;
  unsigned char ti_hund;
  unsigned char ti_sec;
};

struct date {
  short da_year;
  char  da_day;
  char  da_mon;
};

typedef struct {
  int   _cnt;
  char *_ptr;
  char *_base;
  int   _bufsiz;
  int   _flag;
  int   _file;
  char *_name_to_remove;
  int   _fillsize;
} FILE;

struct stat {
  time_t	st_atime;
  time_t	st_ctime;
  dev_t		st_dev;
  gid_t		st_gid;
  ino_t		st_ino;
  mode_t	st_mode;
  time_t	st_mtime;
  nlink_t	st_nlink;
  off_t		st_size;
  off_t		st_blksize;
  uid_t		st_uid;
  dev_t		st_rdev; /* unused */
};

#define S_IFMT		0xf000

#define S_IFREG		0x0000
#define S_IFBLK		0x1000
#define S_IFCHR		0x2000
#define S_IFDIR		0x3000
#define S_IFIFO		0x4000
#define S_IFFIFO	S_IFIFO

typedef unsigned long           fpos_t;


struct ffblk {
  char lfn_magic[6] __attribute__((packed));			
  short lfn_handle __attribute__((packed));	
  unsigned short lfn_ctime __attribute__((packed));
  unsigned short lfn_cdate __attribute__((packed));
  unsigned short lfn_atime __attribute__((packed));
  unsigned short lfn_adate __attribute__((packed));
  char _ff_reserved[5] __attribute__((packed));
  unsigned char  ff_attrib __attribute__((packed));
  unsigned short ff_ftime __attribute__((packed));
  unsigned short ff_fdate __attribute__((packed));
  unsigned long  ff_fsize __attribute__((packed));
  char ff_name[260] __attribute__((packed));
};

#define K_FindFirst             12
#define K_FindNext              13
#define K_mkdir                 17
#define K_rmdir                 18
#define K_rename                16
#define K_fixpath               19
#define K_system                20
#define K_fputs                 124
#define K_fprintf               125
#define K_fopen                 126
#define K_fclose                127
#define K_feof                  128
#define K_ferror                129
#define K_fflush                130
#define K_fgetc                 131
#define K_fgetpos               132
#define K_fgets                 133
#define K_fputc                 134
#define K_fseek                 135
#define K_fsetpos               136
#define K_remove                158
#define K_spawnvpe              174

double (*tan)(double x );
double (*cos)(double x );
double (*sin)(double x );
double (*sqrt)(double x);
double (*floor)(double x );

void (*rewind)( FILE * stream );
int (*fscanf)( FILE * stream, const char * format, ... );
int (*stat)(const char *path, struct stat *buf);
void (*printf)(char *fmt,...);
int (*findfirst)(const char *pathname,struct ffblk *ffblk,int attrib);
void (*copyfile)(char *src,char *dst);
int (*findnext)(struct ffblk *ffblk);
int (*system)(const char *cmd);
FILE *(*fopen)(const char *_filename, const char *_mode);
int (*fprintf)(FILE *_stream, const char *_format, ...);
int (*fputs)(const char *_s, FILE *_stream);
int (*fclose)(FILE *_stream);
int (*feof)(FILE *_stream);
int (*ferror)(FILE *_stream);
int (*fread)(char *ptr,int size,int count,FILE *stream);
int (*fwrite)(char *ptr,int size,int count,FILE *stream);
int (*fflush)(FILE *_stream);
int (*fgetc)(FILE *_stream);
int (*fgetpos)(FILE *_stream, fpos_t *_pos);
char *(*fgets)(char *_s, int _n, FILE *_stream);
int (*fputc)(int _c, FILE *_stream);
int (*fseek)(FILE *_stream, long _offset, int _mode);
int (*fsetpos)(FILE *_stream, const fpos_t *_pos);
int (*remove)(const char *file);
int (*spawnvpe)(int mode,const char *path,char *const argv[],char *const envp[]);
void *(*malloc)(int size);
void (*free)(void *ptr);
char *(*GetPath)(int pid);
int (*mkdir)(const char *path,mode_t mode);
int (*rmdir)(const char *dirname);
int (*rename)(const char *oldname,const char *newname);
int (*fixpath)(const char *inpath,char *outpath);
int (*getdisk)();
char *(*mktemp)(char *template);
void (*sleep)(unsigned int msecs);
void (*getdate)(struct date *d);
void (*gettime)(struct time *t);
void (*int86)(int ivec, union REGS *in, union REGS *out);
void (*_dos_getdrive)(unsigned int *p_drive);
void (*_dos_setdrive)(unsigned int drive, unsigned int *p_drives);

void appinit(DCM *dcm);
static void appmain(void);
int pid;
//****************************************************************
// You can skip over this stuff. This stuff only needs to be
// modified if you are making a DLL.
//****************************************************************
void mod_init(DCM *dcm);
void *var_router(DCM *dcm, int var);
void *proc_router(DCM *dcm, int proc);
void mod_init(DCM *dcm)
{
  dcm->dcm_var=&var_router;
  dcm->dcm_proc=&proc_router;  
}

void *proc_router(DCM *dcm, int proc)
{
	pid=proc;
	appinit(dcm);
	return(0);
}

void appinit(DCM *dcm)
{
DoEvents=dcm->ext_proc(K_DoEvents);
GenEvent=dcm->ext_proc(K_GenEvent);
ExitApp=dcm->ext_proc(K_ExitApp);
SystemFont=dcm->ext_proc(K_SystemFont);
RunApp=dcm->ext_proc(K_RunApp);
GetScreenRes=dcm->ext_proc(K_GetScreenRes);
ShutDown=dcm->ext_proc(K_ShutDown);
sprintf=dcm->ext_proc(K_sprintf);
getmousebuffer=dcm->ext_proc(38);
PutClipboard=dcm->ext_proc(198);
GetClipboard=dcm->ext_proc(199);
//****** DLL FUNCTIONS ***************
Load_DLL=dcm->ext_proc(K_Load_DLL);
Unload_DLL=dcm->ext_proc(K_Unload_DLL);
Get_DLL_Function=dcm->ext_proc(K_Get_DLL_Function);
Register_Device=dcm->ext_proc(197);
Get_Device_Handle=dcm->ext_proc(196);
//******STDIO FUNCTIONS************
getdisk=dcm->ext_proc(K_getdisk);
copyfile=dcm->ext_proc(K_copyfile);
findfirst=dcm->ext_proc(K_FindFirst);
findnext=dcm->ext_proc(K_FindNext);
fopen=dcm->ext_proc(K_fopen);
fclose=dcm->ext_proc(K_fclose);
fputs=dcm->ext_proc(K_fputs);
fprintf=dcm->ext_proc(K_fprintf);
feof=dcm->ext_proc(K_feof);
ferror=dcm->ext_proc(K_ferror);
fflush=dcm->ext_proc(K_fflush);
fgetc=dcm->ext_proc(K_fgetc);
fgetpos=dcm->ext_proc(K_fgetpos);
fgets=dcm->ext_proc(K_fgets);
fputc=dcm->ext_proc(K_fputc);
fseek=dcm->ext_proc(K_fseek);
fsetpos=dcm->ext_proc(K_fsetpos);
remove=dcm->ext_proc(K_remove);
sleep=dcm->ext_proc(123);
spawnvpe=dcm->ext_proc(K_spawnvpe);
rename=dcm->ext_proc(K_rename);
mkdir=dcm->ext_proc(K_mkdir);
rmdir=dcm->ext_proc(K_rmdir);
fixpath=dcm->ext_proc(K_fixpath);
system=dcm->ext_proc(K_system);
getdate=dcm->ext_proc(30);
gettime=dcm->ext_proc(31);
printf=dcm->ext_proc(32);
int86=dcm->ext_proc(33);
_dos_setdrive=dcm->ext_proc(36);
_dos_getdrive=dcm->ext_proc(37);
fread=dcm->ext_proc(201);
fwrite=dcm->ext_proc(202);
stat=dcm->ext_proc(203);
mktemp=dcm->ext_proc(204);
//*******ALLEGRO FUNCTIONS
load_ttf_font=dcm->ext_proc(34);
destroy_font=dcm->ext_proc(35);
load_gif=dcm->ext_proc(K_load_gif);
save_gif=dcm->ext_proc(K_save_gif);
algif_load_animation=dcm->ext_proc(K_algif_load_animation);
text_length=dcm->ext_proc(K_text_length);
text_height=dcm->ext_proc(K_text_height);
scancode_to_ascii=dcm->ext_proc(K_Scancodetoascii);
readkey=dcm->ext_proc(K_ReadKey);
keypressed=dcm->ext_proc(K_KeyPressed);
getscreen=dcm->ext_proc(K_GetScreen);
line=dcm->ext_proc(K_Line);
getmouse=dcm->ext_proc(K_GetMouse);
rectfill=dcm->ext_proc(K_RectFill);
rect=dcm->ext_proc(K_Rect);
circle=dcm->ext_proc(K_Circle);
circlefill=dcm->ext_proc(K_CircleFill);
makecol=dcm->ext_proc(K_MakeCol);
getpixel=dcm->ext_proc(K_GetPixel);
floodfill=dcm->ext_proc(K_FloodFill);
load_bitmap=dcm->ext_proc(K_Load_Bitmap);
save_bitmap=dcm->ext_proc(K_Save_Bitmap);
blit=dcm->ext_proc(K_Blit);
destroy_bitmap=dcm->ext_proc(K_Destroy_Bitmap);
putpixel=dcm->ext_proc(K_PutPixel);
create_bitmap=dcm->ext_proc(K_Create_Bitmap);
textout=dcm->ext_proc(K_TextOut);
textout_centre=dcm->ext_proc(K_TextOut_Centre);
draw_sprite=dcm->ext_proc(K_Draw_Sprite);
masked_blit=dcm->ext_proc(K_Masked_Blit);
set_clip=dcm->ext_proc(K_Set_Clip);
textprintf=dcm->ext_proc(K_TextPrintf);
textprintf_centre=dcm->ext_proc(K_TextPrintf_Centre);
load_jpg=dcm->ext_proc(K_Load_Jpg);
save_jpg=dcm->ext_proc(K_Save_Jpg);
GetPath=dcm->ext_proc(K_GetPath);
scare_mouse=dcm->ext_proc(K_Scare_Mouse);
unscare_mouse=dcm->ext_proc(K_UnScare_Mouse);
create_sub_bitmap=dcm->ext_proc(179);
triangle=dcm->ext_proc(180);
stretch_sprite=dcm->ext_proc(181);
stretch_blit=dcm->ext_proc(182);
masked_stretch_blit=dcm->ext_proc(K_masked_stretch_blit);
rotate_sprite=dcm->ext_proc(183);
malloc=dcm->ext_proc(184);
free=dcm->ext_proc(185);
socket_send=dcm->ext_proc(186);
socket_recieve=dcm->ext_proc(187);
socket_close=dcm->ext_proc(188);
socket_connect=dcm->ext_proc(189);
socket_open=dcm->ext_proc(190);
socket_bind=dcm->ext_proc(191);
socket_listen=dcm->ext_proc(192);
socket_select=dcm->ext_proc(193);
socket_accept=dcm->ext_proc(194);
socket_send_byte=dcm->ext_proc(K_socket_byte);
GetCommand=dcm->ext_proc(195);
set_volume=dcm->ext_proc(K_set_volume);
load_sample=dcm->ext_proc(K_load_sample);
destroy_sample=dcm->ext_proc(K_destroy_sample);
play_sample=dcm->ext_proc(K_play_sample);
adjust_sample=dcm->ext_proc(K_adjust_sample);
GetIkonVersion=dcm->ext_proc(200);
install_int=dcm->ext_proc(205);
remove_int=dcm->ext_proc(206);
_go32_dpmi_lock_data=dcm->ext_proc(207);
_go32_dpmi_lock_code=dcm->ext_proc(208);
tan=dcm->ext_proc(209);
cos=dcm->ext_proc(210);
sin=dcm->ext_proc(211);
get_mouse_mickeys=dcm->ext_proc(212);
fscanf=dcm->ext_proc(213);
clear_to_color=dcm->ext_proc(214);
sqrt=dcm->ext_proc(215);
floor=dcm->ext_proc(216);
rewind=dcm->ext_proc(217);
screen=getscreen();
appmain();
};

