/* Sample Ikon Application
*
*	Compile it with gccfi.
*
*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>	/* needed for gui routines */
#define MAXFILES 1500	//maximum number of pane files supported
#define MAXLINES 15
#define top 30
#define S_IWUSR         00200

//key bindings
#define MOVEUP KEY_UP
#define MOVEDOWN KEY_DOWN
#define DELETE	KEY_DELETE	//delete a file or DIR in current pane
#define COPY	KEY_C		//copy a file or DIR to the other pane
#define SWPANE	KEY_TAB		//switch panes
#define CHDIRY  KEY_ENTER	//change directory
#define PAGEUP  KEY_PGUP	//page up
#define PAGEDOWN KEY_PGDN	//page down
//end key bindings


BITMAP *winbmp;
static void appmain();
char pane1dir[200];		//dir location for pane 1
char pane2dir[200];		//dir location for pane 2
char pane1sel[200];
char pane2sel[200];
char userinput[200];
int screen_w;
int screen_h;
int ourwinid;           //id for our window
int userwin;		//window for user interaction, confirmation, etc.
int key;
int scancode;
int WHITE;
int BLUE;
int YELLOW;
int WINCLR;
int _quit;
int waitkey;	//we will look for a key even if 'ourwinid' is not the current window

int curline;	//which line are we on in the current pane
int curpane;	//which panel are we using right now
int pane1start;	//starting file of pane1
int pane1end;	//ending file of pane1
int pane2start;
int pane2end;
int pane1entries; //how many file entries in pane1
int pane2entries; //second pane
int curfile;

typedef struct panesel PANESEL;
struct panesel{
        int used;
        char filename[20];
        unsigned short date;
        unsigned long size;
	int attrib;	//0 for file 16 for directory
};
PANESEL pane1[MAXFILES];
PANESEL pane2[MAXFILES];

void updatepanes();
void getkeyevent(int data);
void parsedirs(int data);

void *var_router(DCM *dcm, int function)
{
  return(0);
}


void ExitHandler(int data)
{
        if(data==0)
        {
		_quit=1;
		if(userwin!=0)
			CloseWin(userwin);
                CloseWin(ourwinid);	//close our window
                ExitApp(pid);		//exit the application
					//NOTE: pid is a globally define integer
					//that is initialized automatically
					//when your application is run.
					//You DO NOT have to declare it!
        }

}

void uparrow()
{
		if(curline==0)
		{
			if(curpane==1 && pane1start>0)
			{
				pane1start--;
				pane1end--;
			}
			if(curpane==2 && pane2start>0)
			{
				pane2start--;
				pane2end--;
			}
		}
		else
		{
			curline--;
		}
}

void downarrow()
{
		if(curline==MAXLINES)
		{
			if(curpane==1 && pane1[pane1end+1].used!=0)
			{
				pane1start++;
				pane1end++;
			}
			if(curpane==2 && pane2[pane2end+1].used!=0)
			{
				pane2start++;
				pane2end++;
			}
		}
		else
		{
			curline++;
		}
}

void dodelete(int data)
{
		//delete file or directory
		char buff[300];
		int sel;
		memset(buff,0,sizeof(buff));
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].filename[0]=='.')
			{
				return;
			}
			if(pane1[sel].attrib==FA_DIREC && pane1[sel].used==1)
			{
				//remove directory
				strcpy(buff,"deltree /Y ");
				strcat(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				strcat(buff,"/");
				system(buff);
				memset(buff,0,sizeof(buff));
				strcpy(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				rmdir(buff);
			}
			else
			{
				strcpy(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				if(pane1[sel].used==1)
					remove(buff);
			}
		}
		if(curpane==2)
		{
			sel=curline+pane2start;
			if(pane2[sel].filename[0]=='.')
			{
				return;
			}
			if(pane2[sel].attrib==FA_DIREC && pane2[sel].used==1)
			{
				//remove directory
				strcpy(buff,"deltree /Y ");
				strcat(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				strcat(buff,"/");
				system(buff);
				memset(buff,0,sizeof(buff));
				strcpy(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				rmdir(buff);
			}
			else
			{
				strcpy(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				if(pane2[sel].used==1)
					remove(buff);
			}
		}
		parsedirs(0);
		updatepanes();
}

void closeuserwin(int data)
{
	if(userwin==0)
		return;
	CloseWin(userwin);
	userwin=0;
}

void createdir(int data)
{
	char buff[300];
	memset(buff,0,300);
	CloseWin(userwin);
	userwin=0;
	if(curpane==1)
	{
		strcpy(buff,pane1dir);
		strcat(buff,"/");
		strcat(buff,userinput);
		mkdir(buff,S_IWUSR);
	}
	else
	{
		strcpy(buff,pane2dir);
		strcat(buff,"/");
		strcat(buff,userinput);
		mkdir(buff,S_IWUSR);
	}
	parsedirs(0);
	updatepanes();
}

void changedrive(int data)
{
	CloseWin(userwin);
	userwin=0;
	if(curpane==1)
	{
		memset(pane1dir,0,sizeof(pane1dir));
		strcpy(pane1dir,userinput);
	}
	else
	{
		memset(pane2dir,0,sizeof(pane2dir));
		strcpy(pane2dir,userinput);
	}
	parsedirs(0);
	updatepanes();
}

void dorename(int data)
{
	int sel;
	char buff1[300];
	char buff2[300];
	memset(buff1,0,300);
	memset(buff2,0,300);
	CloseWin(userwin);
	userwin=0;
	if(curpane==1)
	{
		sel=curline+pane1start;
		if(pane1[sel].used!=1)
			return;
		if(pane1[sel].filename[0]=='.')
		{
			return;
		}
		strcpy(buff1,pane1dir);
		strcat(buff1,"/");
		strcat(buff1,pane1[sel].filename);
		strcpy(buff2,pane1dir);
		strcat(buff2,"/");
		strcat(buff2,userinput);
		rename(buff1,buff2);
	}
	else
	{
		sel=curline+pane2start;
		if(pane2[sel].used!=1)
			return;
		if(pane2[sel].filename[0]=='.')
		{
			return;
		}
		strcpy(buff1,pane2dir);
		strcat(buff1,"/");
		strcat(buff1,pane2[sel].filename);
		strcpy(buff2,pane2dir);
		strcat(buff2,"/");
		strcat(buff2,userinput);
		rename(buff1,buff2);

	}
	parsedirs(0);
	updatepanes();
}

void getkeyevent(int data)
{
	int t;
	int cnt;
	int sel;
	BITMAP *bmp;
	char buff[300];
	char buff2[300];
	if(_quit==1)
		return;
	if(CurrentWindow()!=ourwinid && waitkey==0)
	{
		GenEvent(getkeyevent,0);
		return;
	}
	t=0;
	t=GetKey();
	if(t==0)
	{
		GenEvent(getkeyevent,0);
		return;
	}
	key=0;
	scancode=0;
	key=(t & 0xff);
	scancode=(t >> 8) & 0xff;
	if(scancode==0)
	{
		GenEvent(getkeyevent,0);
		return;
	}
	if(waitkey==1)
	{
		//waiting for delete confirmation
		if(scancode==KEY_ESC)
		{
			CloseWin(userwin);
			userwin=0;
			waitkey=0;
		}
		if(scancode==KEY_ENTER)
		{
			CloseWin(userwin);
			userwin=0;
			dodelete(0);
			waitkey=0;
		}
		GenEvent(getkeyevent,0);
		return;
	}
	if(scancode==CHDIRY)
	{
		//change the directory
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].used==1 && pane1[sel].attrib==FA_DIREC)
			{
				memset(pane1dir,0,sizeof(pane1dir));
				strcpy(pane1dir,pane1sel);
				curline=0;
				pane1start=0;
				pane1end=MAXLINES;
				parsedirs(0);
				updatepanes();
			}
		}
		else
		{
			sel=curline+pane2start;
			if(pane2[sel].used==1 && pane2[sel].attrib==FA_DIREC)
			{
				memset(pane2dir,0,sizeof(pane2dir));
				strcpy(pane2dir,pane2sel);
				pane2start=0;
				pane2end=MAXLINES;
				curline=0;
				parsedirs(0);
				updatepanes();
			}
		}
	}
	if(scancode==PAGEUP)
	{
		cnt=0;
		do{
			uparrow();
			cnt++;
			if(cnt==MAXLINES+1)
				break;
		}while(1);
		updatepanes();
	}
	if(scancode==KEY_F10)
	{
		_quit=1;
		ExitHandler(0);
		return;
	}
	if(scancode==PAGEDOWN)
	{
		cnt=0;
		do{
			downarrow();
			cnt++;
			if(cnt==MAXLINES+1)
				break;
		}while(1);
		updatepanes();

	}
	if(scancode==KEY_F3 || scancode==KEY_F4)
	{
		memset(buff,0,300);
		strcpy(buff,"programs\\edit.app ");
		if(curpane==1)
		{
			sel=curline+pane1start;
			strcat(buff,pane1dir);
			strcat(buff,"\\");
			strcat(buff,pane1[sel].filename);
		}
		else
		{
			sel=curline+pane2start;
			strcat(buff,pane2dir);
			strcat(buff,"\\");
			strcat(buff,pane2[sel].filename);
		}
		RunApp(buff);
	}
	if(scancode==KEY_END)
	{
		cnt=0;
		do{
			downarrow();
			cnt++;
			if(cnt==pane1entries && curpane==1)
				break;
			if(cnt==pane2entries && curpane==2)
				break;
		}while(1);
		updatepanes();
	}
	if(scancode==KEY_HOME)
	{
		curline=0;
		if(curpane==1)
		{
			pane1start=0;
			pane1end=MAXLINES;
		}
		if(curpane==2)
		{
			pane2start=0;
			pane2end=MAXLINES;
		}
		updatepanes();
	}
	if(scancode==MOVEUP)
	{
		uparrow();
		updatepanes();
	}
	if(scancode==MOVEDOWN)
	{
		downarrow();
		updatepanes();
	}
	if(scancode==SWPANE)
	{
		if(curpane==1)
		{
			curpane=2;
			if(curline>pane2entries-pane2start)
			{
				curline=pane2entries-pane2start;
			}

		}
		else
		{
			curpane=1;
			if(curline>pane1entries-pane1start)
			{
				curline=pane1entries-pane1start;
			}
		}
		updatepanes();
	}
	if(scancode==KEY_F5)
	{
		//copy file or directory
		memset(buff,0,sizeof(buff));
		memset(buff2,0,sizeof(buff2));
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].attrib==FA_DIREC)
			{
				strcpy(buff,"xcopy /H /Y /E /I /R ");
				strcat(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				strcat(buff," ");
				strcat(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				//strcat(buff,"/");
				if(pane1[sel].used==1)
				{
					system(buff);
				}
			}
			else
			{
				strcpy(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				strcpy(buff2,pane2dir);
				strcat(buff2,"\\");
				strcat(buff2,pane1[sel].filename);
				if(pane1[sel].used==1)
					copyfile(buff,buff2);
			}
		}
		else
		{
			sel=curline+pane2start;
			if(pane2[sel].attrib==FA_DIREC)
			{
				strcpy(buff,"xcopy /H /Y /E /I /R ");
				strcat(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				strcat(buff," ");
				strcat(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				//strcat(buff,"/");
				if(pane2[sel].used==1)
				{
					system(buff);
				}
			}
			else
			{
				strcpy(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				strcpy(buff2,pane1dir);
				strcat(buff2,"\\");
				strcat(buff2,pane2[sel].filename);
				if(pane2[sel].used==1)
					copyfile(buff,buff2);
			}

		}
		parsedirs(0);
		updatepanes();
	}
	if(scancode==KEY_F8)
	{
		//need to confirm that a user wants to delete a file or DIR
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].used!=1)
			{
				GenEvent(getkeyevent,0);
				return;
			}
		}
		else
		{
			sel=curline+pane2start;
			if(pane2[sel].used!=1)
			{
				GenEvent(getkeyevent,0);
				return;
			}
		}

		userwin=MakeWindow(40,40,300,65,"Confirm Delete",0,0);
		bmp=GetWinBMP(userwin);
		textout(bmp,SystemFont(),"Okay to delete this entry?",20,23,0);
		textout(bmp,SystemFont(),"[ENTER]ok   [ESC]cancel",40,43,0);
		waitkey=1;
		SetFocusOn(userwin);
		RefreshWin(userwin);
	}
	if(scancode==KEY_F6)
	{
		//move files
		memset(buff,0,sizeof(buff));
		memset(buff2,0,sizeof(buff2));
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].filename[0]=='.')
			{
				GenEvent(getkeyevent,0);
				return;
			}
			if(pane1[sel].attrib==FA_DIREC)
			{
				strcpy(buff,"xcopy /H /Y /E /I /R ");
				strcat(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				strcat(buff," ");
				strcat(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				//strcat(buff,"/");
				if(pane1[sel].used==1)
				{
					system(buff);
				}
			}
			else
			{
				strcpy(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane1[sel].filename);
				strcpy(buff2,pane2dir);
				strcat(buff2,"\\");
				strcat(buff2,pane1[sel].filename);
				if(pane1[sel].used==1)
					copyfile(buff,buff2);
			}
		}
		else
		{
			sel=curline+pane2start;
			if(pane2[sel].filename[0]=='.')
			{
				GenEvent(getkeyevent,0);
				return;
			}
			if(pane2[sel].attrib==FA_DIREC)
			{
				strcpy(buff,"xcopy /H /Y /E /I /R ");
				strcat(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				strcat(buff," ");
				strcat(buff,pane1dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				//strcat(buff,"/");
				if(pane2[sel].used==1)
				{
					system(buff);
				}
			}
			else
			{
				strcpy(buff,pane2dir);
				strcat(buff,"\\");
				strcat(buff,pane2[sel].filename);
				strcpy(buff2,pane1dir);
				strcat(buff2,"\\");
				strcat(buff2,pane2[sel].filename);
				if(pane2[sel].used==1)
					copyfile(buff,buff2);
			}

		}
		//then delete the old ones
		memset(buff,0,sizeof(buff));
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].filename[0]=='.')
			{
				GenEvent(getkeyevent,0);
				return;
			}
			if(pane1[sel].attrib==FA_DIREC && pane1[sel].used==1)
			{
				//remove directory
				strcpy(buff,"deltree /Y ");
				strcat(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				strcat(buff,"/");
				system(buff);
				memset(buff,0,sizeof(buff));
				strcpy(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				rmdir(buff);
			}
			else
			{
				strcpy(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				if(pane1[sel].used==1)
					remove(buff);
			}
		}
		if(curpane==2)
		{
			sel=curline+pane2start;
			if(pane2[sel].filename[0]=='.')
			{
				GenEvent(getkeyevent,0);
				return;
			}
			if(pane2[sel].attrib==FA_DIREC && pane2[sel].used==1)
			{
				//remove directory
				strcpy(buff,"deltree /Y ");
				strcat(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				strcat(buff,"/");
				system(buff);
				memset(buff,0,sizeof(buff));
				strcpy(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				rmdir(buff);
			}
			else
			{
				strcpy(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				if(pane2[sel].used==1)
					remove(buff);
			}
		}
		parsedirs(0);
		updatepanes();

	}
	if(scancode==KEY_F7)
	{
		//create a dir
		if(userwin==0)
		{
		        userwin=MakeWindow(300,200,200,80,"Create Directory",closeuserwin,0);
		        memset(userinput,0,sizeof(userinput));
		        AddEditBox(userwin,5,22,185,userinput,createdir,3);
		        MakeButton(userwin,55,50,"Okay",createdir,3);
		        MakeButton(userwin,107,50,"Cancel",closeuserwin,0);
			SetFocusOn(userwin);
		        RefreshWin(userwin);
		}
	}
	if(scancode==KEY_F12)
	{
		//select drive
		if(userwin==0)
		{
		        userwin=MakeWindow(300,200,200,80,"Change Drive",closeuserwin,0);
		        memset(userinput,0,sizeof(userinput));
			strcpy(userinput,"c:\\");
		        t=AddEditBox(userwin,5,22,185,userinput,changedrive,3);
		        MakeButton(userwin,55,50,"Okay",changedrive,3);
		        MakeButton(userwin,107,50,"Cancel",closeuserwin,0);
			RefreshEditBox(t);
			SetFocusOn(userwin);
		        RefreshWin(userwin);
		}
	}
	if(scancode==KEY_F11)
	{
		//run selected program
		memset(buff,0,sizeof(buff));
		if(curpane==1)
		{
			sel=curline+pane1start;
			if(pane1[sel].used==1)
			{
				strcpy(buff,pane1dir);
				strcat(buff,"/");
				strcat(buff,pane1[sel].filename);
				RunApp(buff);
			}
		}
		else
		{
			sel=curline+pane2start;
			if(pane2[sel].used==1)
			{
				strcpy(buff,pane2dir);
				strcat(buff,"/");
				strcat(buff,pane2[sel].filename);
				RunApp(buff);
			}
		}
	}
	if(scancode==KEY_F2)
	{
		//rename file
		if(userwin==0)
		{
		        userwin=MakeWindow(300,200,200,80,"Rename File",closeuserwin,0);
		        memset(userinput,0,sizeof(userinput));
		        AddEditBox(userwin,5,22,185,userinput,dorename,3);
		        MakeButton(userwin,55,50,"Okay",dorename,3);
		        MakeButton(userwin,107,50,"Cancel",closeuserwin,0);
			SetFocusOn(userwin);
		        RefreshWin(userwin);
		}
	}
	if(scancode==KEY_F1)
	{
		//find the directory where the komander.txt file is.
		memset(buff,0,sizeof(buff));
		strcpy(buff,"programs\\edit.app ");
		strcat(buff,GetPath(pid));
		strcat(buff,"/");
		strcat(buff,"komander.txt");
		RunApp(buff);
	}
	GenEvent(getkeyevent,0);
}

void clearpanes()
{
	rectfill(winbmp,3,top+20,winbmp->w-3,winbmp->h-3,WINCLR);
	rectfill(winbmp,3,top+45,(winbmp->w/2)-5,422-top,BLUE);
	rectfill(winbmp,(winbmp->w/2)+5,top+45,winbmp->w-4,422-top,BLUE);
	//status boxes for dirs and cur selected file
	rectfill(winbmp,3,top+20,(winbmp->w/2)-5,top+20+20,WHITE);
	rectfill(winbmp,winbmp->w/2+5,top+20,winbmp->w-4,top+20+20,WHITE);
	rectfill(winbmp,3,winbmp->h-21-top,winbmp->w-5,winbmp->h-4-top,WHITE);
	rect(winbmp,3,top+20,(winbmp->w/2)-5,top+20+20,0);
	rect(winbmp,winbmp->w/2+5,top+20,winbmp->w-4,top+20+20,0);
	rect(winbmp,3,winbmp->h-22-top,winbmp->w-5,winbmp->h-4-top,0);

}

void updatepanes()
{
	//we parse the dirs for both panes here starting
	//with the first pane.
	char buff[300];
	FONT *font;
	int cnt;
	int thisline;
	clearpanes();
	font=SystemFont();
	if(curpane==1)
	{
		//first pane
		rectfill(winbmp,4,top+45+(curline*20),(winbmp->w/2)-5,top+45+(curline*20)+20,0);
	}
	else
	{
		//second pane
		rectfill(winbmp,(winbmp->w/2)+5,top+45+(curline*20),winbmp->w-5,top+45+(curline*20)+20,0);
	}
	//now update the file listing in each pane
	cnt=0;
	thisline=0;
	pane1entries=0;
	do{
		memset(buff,0,sizeof(buff));
		pane1entries++;
		if(pane1[cnt].used!=1)
			break;
		if(cnt>(pane1start-1) && thisline<MAXLINES+1)
		{
			if((pane1[cnt].attrib & FA_DIREC)==FA_DIREC)
			{
				textout(winbmp,font,pane1[cnt].filename,6,top+48+(thisline*20),YELLOW);
			}
			else
			{
				textout(winbmp,font,pane1[cnt].filename,6,top+48+(thisline*20),WHITE);
				memset(buff,0,sizeof(buff));
				itoa(pane1[cnt].size,buff,10);
				strcat(buff," bytes");
				textout(winbmp,font,buff,6+130,top+48+(thisline*20),YELLOW);
			}
			thisline++;
		}
		cnt++;
	}while(1);
	cnt=0;
	thisline=0;
	pane2entries=0;
	do{
		memset(buff,0,sizeof(buff));
		pane2entries++;
		if(pane2[cnt].used!=1)
			break;
		if(cnt>(pane2start-1) && thisline<MAXLINES+1)
		{
			if((pane2[cnt].attrib & FA_DIREC)==FA_DIREC)
			{
				textout(winbmp,font,pane2[cnt].filename,(winbmp->w/2)+6,top+48+(thisline*20),YELLOW);
			}
			else
			{
				textout(winbmp,font,pane2[cnt].filename,(winbmp->w/2)+6,top+48+(thisline*20),WHITE);
				memset(buff,0,sizeof(buff));
				itoa(pane2[cnt].size,buff,10);
				strcat(buff," bytes");
				textout(winbmp,font,buff,(winbmp->w/2)+6+130,top+48+(thisline*20),YELLOW);

			}
			thisline++;
		}
		cnt++;
	}while(1);
	textout(winbmp,font,pane1dir,6,top+23,0);
	textout(winbmp,font,pane2dir,6+(winbmp->w/2),top+23,0);
	memset(buff,0,sizeof(buff));
	if(curpane==1)
	{
		memset(pane1sel,0,sizeof(pane1sel));
		fixpath(pane1dir,buff);
		strcat(buff,"/");
		curfile=pane1start+curline;
		if(pane1[curfile].used==1)
		{
			strcat(buff,pane1[curfile].filename);
			strcpy(pane1sel,buff);
		}
	}
	if(curpane==2)
	{
		memset(pane2sel,0,sizeof(pane2sel));
		fixpath(pane2dir,buff);
		strcat(buff,"/");
		curfile=pane2start+curline;
		if(pane2[curfile].used==1)
		{
			strcat(buff,pane2[curfile].filename);
			strcpy(pane2sel,buff);
		}
	}
	textout(winbmp,font,buff,6,winbmp->h-20-top,0);
	textout(winbmp,font,"[F1]Help",6,winbmp->h-top+2,0);
	RefreshWin(ourwinid);
}

void parsedirs(int data)
{
	int cnt;
	int temp;
	int done;
	char thispath[300];
	struct stat st;
	struct ffblk f;
	cnt=0;
	do{
		if(pane1[cnt].used==1)
		{
			memset(pane1[cnt].filename,0,20);
			pane1[cnt].attrib=0;
			pane1[cnt].used=0;
		}
		if(pane2[cnt].used==1)
		{
			pane2[cnt].used=0;
			memset(pane2[cnt].filename,0,20);
			pane2[cnt].attrib=0;
		}
		cnt++;
		if(cnt==MAXFILES)
			break;
	}while(1);
	memset(thispath,0,sizeof(thispath));
	fixpath(pane1dir,thispath);
	memset(pane1dir,0,sizeof(pane1dir));
	strcpy(pane1dir,thispath);
	strcat(thispath,"/*.*");
	done=findfirst(thispath,&f,FA_DIREC);
	cnt=0;
	while(!done)
	{
		strcpy(pane1[cnt].filename,f.ff_name);
		pane1[cnt].date=f.ff_fdate;
		pane1[cnt].size=f.ff_fsize;
		pane1[cnt].attrib=f.ff_attrib;
		pane1[cnt].used=1;
	        done=findnext(&f);
		cnt++;
	}


	memset(thispath,0,sizeof(thispath));
	fixpath(pane2dir,thispath);
	memset(pane2dir,0,sizeof(pane2dir));
	strcpy(pane2dir,thispath);
	strcat(thispath,"/*.*");
	done=findfirst(thispath,&f,FA_DIREC);
	cnt=0;
	while(!done)
	{
		strcpy(pane2[cnt].filename,f.ff_name);
		pane2[cnt].date=f.ff_fdate;
		pane2[cnt].size=f.ff_fsize;
		pane2[cnt].attrib=f.ff_attrib;
		pane2[cnt].used=1;
                done=findnext(&f);
		cnt++;
	}

}

static void appmain()	//called appmain, not main!!!
{
	InitGUI();
	WHITE=makecol(0xff,0xff,0xff);
	BLUE=makecol(0xf,0xf,0xff);
	YELLOW=makecol(0xff,0xff,0x00);
	WINCLR=makecol(210,210,210);
	GetScreenRes(&screen_w,&screen_h);
	screen_w=screen_w-20;
        ourwinid=MakeWindow(0,0,screen_w-4,450,"Ikon Kommander 0.1",ExitHandler,0);
	winbmp=GetWinBMP(ourwinid);
        RefreshWin(ourwinid);
	SetFocusOn(ourwinid);
	curpane=1;	//left pane is active to start off with
	curline=0;
	pane1start=0;
	pane1end=MAXLINES;
	pane2start=0;
	pane2end=MAXLINES;
	parsedirs(0);
	updatepanes();	//update all the files in both panes
        RefreshWin(ourwinid);
	SetFocusOn(ourwinid);
	waitkey=0;
	userwin=0;
	GenEvent(getkeyevent,0);
};



